#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glpng.h>
#include <math.h>
#include <string.h>
#include "SDL.h"

/* screen width, height, and bit depth */
#define SCREEN_WIDTH  640
#define SCREEN_HEIGHT 480
#define SCREEN_BPP     16
#define XSIZE xsize
#define YSIZE ysize
#define SCALE 6
#define MAX(x,y) ((x>y) ? x : y)
#define MIN(x,y) ((x<y) ? x : y)
#define RANGE(x,y,z) MIN(MAX(x,y),z)
//#define RANGE(x,y,z) ((x<y) ? ((y<z) ? y:z) : x)

typedef struct { /* data for the type of tile*/
 GLfloat height[SCALE][SCALE];
 GLfloat r,g,b;
 GLuint texture;
} tile;

int xsize, ysize;
int Frames = 0,T0=0;

tile tarr[13];/*The array of basic types of tiles*/
int wwidth,wheight;
int xloc = 0;
int yloc = 0;


GLfloat **hlist;/*array of heights*/
tile ***ttype;/*pointer to the type of each tile*/
int keydown = 0;
int keyd = 0;
/* Define our booleans */
#define TRUE  1
#define FALSE 0

/* This is our SDL surface */
SDL_Surface *surface;

/* function to release/destroy our resources and restoring the old desktop */
void Quit( int returnCode )
{
    /* clean up the window */
    SDL_Quit( );

    /* and exit appropriately */
    exit( returnCode );
}

/* function to reset our viewport after a window resize */
void genterrain() {
    int x,y;
    for (x = 0;x<13;x++) tarr[x].texture = 0;
    tarr[0].r = 0.9f;     tarr[0].g = 0.9f;     tarr[0].b = 0.5f;/*ocean*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[0].height[x][y] = 0;
     }
    }
    tarr[1].r = 0.9f;     tarr[1].g = 0.9f;     tarr[1].b = 0.5f;/*river*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[1].height[x][y] = 0.95;
     }
    }
    tarr[2].r = 0.0f; tarr[2].g = 1.0f; tarr[2].b = 0.0f;/*grassland*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[2].height[x][y] = 2;
     }
    }
    for (x = 0;x<SCALE;x++) {  /*mountains*/
     for (y = 0;y<SCALE;y++) {
      tarr[3].height[x][y] = (rand() % 3) + 3;
     }
    }
    tarr[4].r = 0.7f; tarr[4].g = 1.0f; tarr[4].b = 0.0f;  /*plains*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[4].height[x][y] = 2;
     }
    }
    tarr[5].r = 0.0f; tarr[5].g = 0.5f; tarr[5].b = 0.0f; /*Hills*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[5].height[x][y] = (rand() % 2) + 2;
     }
    }
    tarr[6].r = 1.0f; tarr[6].g = 1.0f; tarr[6].b = 0.0f; /*Desert*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[6].height[x][y] = 2;
     }
    }
    tarr[7].r = 1.0f; tarr[7].g = 1.0f; tarr[7].b = 1.0f; /*Arctic*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[7].height[x][y] = 2;
     }
    }
    tarr[8].r = 0.8f; tarr[8].g = 1.0f; tarr[8].b = 0.8f; /*Tundra*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[8].height[x][y] = 2;
     }
    }
    tarr[9].r = 1.0f; tarr[9].g = 0.0f; tarr[9].b = 1.0f; /*Forest*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[9].height[x][y] = 2;
     }
    }
    tarr[10].r = 1.0f; tarr[10].g = 0.0f; tarr[10].b = 1.0f; /*Swamp*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[10].height[x][y] = 1.5;
     }
    }
    tarr[11].r = 1.0f; tarr[11].g = 0.0f; tarr[11].b = 1.0f; /*Jungle*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[11].height[x][y] = 2;
     }
    }
    tarr[12].r = 1.0f; tarr[12].g = 0.0f; tarr[12].b = 1.0f;  /*Dunno*/
    for (x = 0;x<SCALE;x++) {
     for (y = 0;y<SCALE;y++) {
      tarr[12].height[x][y] = 2;
     }
    }

}

int chwindow();

int resizeWindow( int width, int height )
{
    wwidth = width;
    wheight = height;
    return chwindow();
}
int chwindow() {   
    /* Height / width ratio */
    GLfloat ratio;

    /* Protect against a divide by zero */
    if ( wheight == 0 )
	wheight = 1;

    ratio = ( GLfloat )wwidth / ( GLfloat )wheight;

    /* Setup our viewport. */
    glViewport( 0, 0, ( GLsizei )wwidth, ( GLsizei )wheight );

    /* change to the projection matrix and set our viewing volume. */
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity( );

    /* Set our perspective */
    gluPerspective( 45.0f, ratio, 0.1f, 400.0f );

    glRotatef(-60.0f,1.0f,0.0f,0.0f);
    glRotatef(-45.f,0.0f,0.0f,1.0f);
/*glRotatef(-135.0f,0.0f,0.0f,1.0f);*/
    glTranslated(xloc,yloc,0);
    /* Make sure we're chaning the model view and not the projection */
    glMatrixMode( GL_MODELVIEW );

    /* Reset The View */
    glLoadIdentity( );

    return( TRUE );
}

/* function to handle key press events */

void handleKeyPress( SDL_keysym *keysym )
{
    switch ( keysym->sym )
	{
	case SDLK_ESCAPE:
	    /* ESC key was pressed */
	    Quit( 0 );
	    break;
	case SDLK_F1:
	    /* F1 key was pressed
	     * this toggles fullscreen mode
	     */
	    SDL_WM_ToggleFullScreen( surface );
	    break;
        case SDLK_UP:
         yloc = yloc-1;
         keydown = 1;
         keyd = 0;
         chwindow(); 
         break;
        case SDLK_DOWN:
         yloc = yloc+1;
         keydown = 1;
         keyd = 1;
         chwindow(); 
         break;
        case SDLK_LEFT:
         xloc = xloc+1;
         keydown  = 1;
         keyd = 2;
         chwindow(); 
         break;
        case SDLK_RIGHT:
         xloc = xloc-1;
         keydown = 1;
         keyd = 3;
         chwindow(); 
         break;
	default:
	    break;
	}

    return;
}

void handleKeyUp(SDL_keysym *keysym) {
 switch (keysym->sym) {
   case SDLK_UP:
   case SDLK_DOWN:
   case SDLK_LEFT:
   case SDLK_RIGHT:
     keydown = 0;
     break;
   default:
     break;
  }
}


/* general OpenGL initialization function */
int initGL( GLvoid )
{
    glEnable(GL_TEXTURE_2D);
    /* Enable smooth shading */
    glShadeModel( GL_SMOOTH );

    /* Set the background black */
    glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );

    /* Depth buffer setup */
    glClearDepth( 1.0f );

    /* Enables Depth Testing */
    glEnable( GL_DEPTH_TEST );

    /* The Type Of Depth Test To Do */
    glDepthFunc( GL_LEQUAL );

    /* Really Nice Perspective Calculations */
  /*  glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );*/


    return( TRUE );
}

/* Here goes our drawing code */
int drawGLScene( GLvoid )
{
    /* These are to calculate our fps */

    GLint x,y,x1,y1,bx,by,bbx,bby,ctext=0;
    GLfloat incr = 1.0f/((GLfloat)(SCALE-1));
    GLfloat locol,locob;
    /* Clear The Screen And The Depth Buffer */
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

    /* Move Left 1.5 Units And Into The Screen 6.0 */
    glLoadIdentity();
    glTranslatef(0.0f,0.0f,-20.0f);
    glColor3f(0.5f,0.5f,0.5f);

    for (x =RANGE(0,(xloc-10)/(SCALE-1),XSIZE);x<RANGE(0,(xloc + 160)/(SCALE-1),XSIZE);x++) {
     for (y =RANGE(0,(-yloc-10)/(SCALE-1),YSIZE);y<RANGE(0,(-yloc + 160)/(SCALE-1),YSIZE);y++) {
       bx = x*(SCALE-1); by = y*(SCALE-1);
       if (ttype[x][y]->texture) {
         glColor3f(1.0f,1.0f,1.0f);
         if (ctext != ttype[x][y]->texture) {
           glBindTexture(GL_TEXTURE_2D,ttype[x][y]->texture);
           ctext = ttype[x][y]->texture;
         }
         glBegin(GL_TRIANGLES);
          for (x1 = 0;x1<(SCALE-1);x1++) {
           bbx = x1+bx;
           for (y1 = 0;y1<(SCALE-1);y1++) {
            bby = y1+by;
            locol = x1/(GLfloat)(SCALE-1); locob = y1/(GLfloat)(SCALE-1);
            glTexCoord2f(locol,locob); glVertex3d(-bbx,bby,hlist[bbx][bby]);
            glTexCoord2f(locol,locob+incr); glVertex3d(-bbx,bby+1,hlist[bbx][bby+1]);
            glTexCoord2f(locol+incr,locob); glVertex3d(-bbx-1,bby,hlist[bbx+1][bby]);
            glTexCoord2f(locol,locob+incr); glVertex3d(-bbx,bby+1,hlist[bbx][bby+1]);
            glTexCoord2f(locol+incr,locob+incr); glVertex3d(-bbx-1,bby+1,hlist[bbx+1][bby+1]);
            glTexCoord2f(locol+incr,locob); glVertex3d(-bbx-1,bby,hlist[bbx+1][bby]);
           }
          }
         glEnd();
       } else if (ttype[x][y]->r + ttype[x][y]->g+ttype[x][y]->b > 0.0f) {
         if (!(hlist[bx][by] < 1 && 
               hlist[bx+(SCALE-1)][by] < 1 && 
               hlist[bx][by+(SCALE-1)] < 1 && 
               hlist[bx+(SCALE-1)][by+(SCALE-1)] < 1 && 
               hlist[bx+(SCALE-1)/2][by+(SCALE-1)/2] < 1)) {  
           if (ctext != 0) {
             glBindTexture(GL_TEXTURE_2D,0);
             ctext = 0;  
           }      
           glBegin(GL_TRIANGLES);
            glColor3f(ttype[x][y]->r,ttype[x][y]->g,ttype[x][y]->b);
            for (x1 = 0;x1<(SCALE-1);x1++) {
             bbx = x1+bx;
             for (y1 = 0;y1<(SCALE-1);y1++) {
              bby = y1+by;
              glVertex3d(-bbx,bby,hlist[bbx][bby]);
              glVertex3d(-bbx,bby+1,hlist[bbx][bby+1]);
              glVertex3d(-bbx-1,bby,hlist[bbx+1][bby]);
              glVertex3d(-bbx,bby+1,hlist[bbx][bby+1]);
              glVertex3d(-bbx-1,bby+1,hlist[bbx+1][bby+1]);
              glVertex3d(-bbx-1,bby,hlist[bbx+1][bby]);
             }
            }
           glEnd();
         }
       } else {  
         if (!(hlist[bx][by] < 1 && 
               hlist[bx+(SCALE-1)][by] < 1 && 
               hlist[bx][by+(SCALE-1)] < 1 && 
               hlist[bx+(SCALE-1)][by+(SCALE-1)] < 1 && 
               hlist[bx+(SCALE-1)/2][by+(SCALE-1)/2] < 1)) { 
           if (ctext != 0) {
             glBindTexture(GL_TEXTURE_2D,0);
             ctext = 0;  
           }        
           glBegin(GL_TRIANGLES);
            for (x1 = 1;x1<(SCALE);x1++) { /*I have absolutely no clue what's wrong with this one*/
             bbx=bx+x1-1;
             for (y1 = 1;y1<(SCALE);y1++) {
              bby=by+y1-1;
              glColor3f(((GLfloat)hlist[bbx][bby])*0.2f,((GLfloat)hlist[bbx][bby])*0.2f,((GLfloat)hlist[bbx][bby])*0.2f);
              glVertex3d(-bbx,bby,hlist[bbx][bby]);
              glColor3f(((GLfloat)hlist[bbx][bby+1])*0.2f,((GLfloat)hlist[bbx][bby+1])*0.2f,((GLfloat)hlist[bbx][bby+1])*0.2f);
              glVertex3d(-bbx,bby+1,hlist[bbx][bby+1]);
              glColor3f(((GLfloat)hlist[bbx+1][bby])*0.2f,((GLfloat)hlist[bbx+1][bby])*0.2f,((GLfloat)hlist[bbx+1][bby])*0.2f);
              glVertex3d(-bbx-1,bby,hlist[bbx+1][bby]);
              glColor3f(((GLfloat)hlist[bbx][bby+1])*0.2f,((GLfloat)hlist[bbx][bby+1])*0.2f,((GLfloat)hlist[bbx][bby+1])*0.2f);
              glVertex3d(-bbx,bby+1,hlist[bbx][bby+1]);
              glColor3f(((GLfloat)hlist[bbx+1][bby+1])*0.2f,((GLfloat)hlist[bbx+1][bby+1])*0.2f,((GLfloat)hlist[bbx+1][bby+1])*0.2f);
              glVertex3d(-bbx-1,bby+1,hlist[bbx+1][bby+1]);
              glColor3f(((GLfloat)hlist[bbx+1][bby])*0.2f,((GLfloat)hlist[bbx+1][bby])*0.2f,((GLfloat)hlist[bbx+1][bby])*0.2f);
              glVertex3d(-bbx-1,bby,hlist[bbx+1][bby]);
             }
            } 
           glEnd();
         }
       }
     }
    }
    glBindTexture(GL_TEXTURE_2D,0);
    #define DIPDOWN
    #undef FLAT

    #ifdef DIPDOWN
    glColor3f(0.0f,0.0f,0.0f);
    for ( x =RANGE(0,xloc/(SCALE-1),XSIZE);x<RANGE(0,(xloc+150)/(SCALE-1),XSIZE);x++) {
     glBegin(GL_LINE_STRIP);
      for ( y =RANGE(0,-yloc,YSIZE*(SCALE-1));y<RANGE(0,-yloc+150,YSIZE*(SCALE-1));y++) {
       glVertex3d(-x*(SCALE-1),y,MAX(1,hlist[x*(SCALE-1)][y])+0.1f);
      }
     glEnd();
    }     
    for ( y =RANGE(0,-yloc/(SCALE-1),YSIZE);y<RANGE(0,(-yloc+150)/(SCALE-1),YSIZE);y++) {
     glBegin(GL_LINE_STRIP);
      for ( x =RANGE(0,xloc,XSIZE*(SCALE-1));x<RANGE(0,xloc+150,XSIZE*(SCALE-1));x++) {
       glVertex3d(-x,y*(SCALE-1),MAX(1,hlist[x][y*(SCALE-1)])+0.1f);
      }
     glEnd();
    }
    #endif
    #ifdef FLAT
    glColor3f(0.0f,0.0f,0.0f);
    for ( x =0;x<XSIZE;x++) {
     glBegin(GL_LINE_STRIP);
      glVertex3d(-x*(SCALE),0,10.0f);
      glVertex3d(-x*(SCALE),YSIZE*(SCALE),10.0f);
     glEnd();
    }     

    for ( y =0;y<YSIZE;y++) {
     glBegin(GL_LINE_STRIP);
      glVertex3d(0,y*(SCALE),10.0f);
      glVertex3d(-XSIZE*(SCALE),y*(SCALE),10.0f);
     glEnd();
    }
    #endif

    /*Ocean*/
    glColor3f(0.0f,0.0f,1.0f);
    glBegin(GL_QUADS);
     glVertex3d(-xloc+10,-yloc-10,1);
     glVertex3d(-xloc-160,-yloc-10,1);     
     glVertex3d(-xloc-160,-yloc+160,1);
     glVertex3d(-xloc+10,-yloc+160,1);
    glEnd();

    Frames++;
    {
	   GLint t = SDL_GetTicks();
	   if (t - T0 >= 5000) {
	     GLfloat seconds = (t - T0) / 1000.0;
	     GLfloat fps = Frames / seconds;
	     printf("%d frames in %g seconds = %g FPS\n", Frames, seconds, fps);
	     T0 = t;
	     Frames = 0;
	   }
    }


    SDL_GL_SwapBuffers( );
    return( TRUE );
}

int main( int argc, char **argv )
{
    /* Flags to pass to SDL_SetVideoMode */
    int videoFlags,x,y,x1,y1,st;
    /* main loop variable */
    int done = FALSE;
  
    char inbuf[400];
    /* used to collect events */
    SDL_Event event;
    /* this holds some info about our display */
    const SDL_VideoInfo *videoInfo;
    /* whether or not the window is active */
    int isActive = TRUE;
    FILE *fp;
    char terr_chars[] = " rgmphdatfsj";
    srand(SDL_GetTicks());

    genterrain();

    fp = fopen(argv[1],"r");
    x = 0;
    while(x < 2) {
     fgets(inbuf,400,fp);
     if (strncmp(inbuf,"width=",6) == 0) {
      xsize = atoi(inbuf+6);
      x++;
     }
     if (strncmp(inbuf,"height=",7) == 0) {
      ysize = atoi(inbuf+7);
      x++;
     }
    }
    
    hlist = malloc(xsize*SCALE*sizeof(GLfloat*));
    for (x = 0;x<xsize*SCALE;x++) hlist[x] = malloc(ysize*SCALE*sizeof(GLfloat)); 
    ttype = malloc(xsize*sizeof(tile**));
    for (x = 0;x<xsize;x++) ttype[x] = malloc(ysize*SCALE*sizeof(tile*));
 
    printf("%d %d\n", xsize,ysize);
    x = 0;
    while (x == 0) {
     fgets(inbuf,400,fp);
     if (strncmp("t000=",inbuf,5) == 0) x++;
    }
    for (y=0;y<YSIZE;y++) {
     for(x=0;x<XSIZE;x++) {
      st = strchr(terr_chars,inbuf[x+6]) - terr_chars;
      ttype[x][y] = &(tarr[st]);
      for (x1= 0;x1<SCALE;x1++) {
       for (y1 = 0;y1<SCALE;y1++) {
        if (x1 == 0&& y1==0) {
         hlist[x*(SCALE-1)+x1][y*(SCALE-1)+y1] = (hlist[x*(SCALE-1)+x1][y*(SCALE-1)+y1]*3 +tarr[st].height[x1][y1])/4;
        } else if (x1 ==  0|| y1 == 0) {
         hlist[x*(SCALE-1)+x1][y*(SCALE-1)+y1] = (hlist[x*(SCALE-1)+x1][y*(SCALE-1)+y1] +tarr[st].height[x1][y1])/2;
        } else {
         hlist[x*(SCALE-1)+x1][y*(SCALE-1)+y1] = tarr[st].height[x1][y1];
        }
       } 
      }
     }
     fgets(inbuf,400,fp);
    }
    fclose(fp);
    /* initialize SDL */
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
	{
	    fprintf( stderr, "Video initialization failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}

    /* Fetch the video info */
    videoInfo = SDL_GetVideoInfo( );

    if ( !videoInfo )
	{
	    fprintf( stderr, "Video query failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}

    /* the flags to pass to SDL_SetVideoMode */
    videoFlags  = SDL_OPENGL;          /* Enable OpenGL in SDL */
    videoFlags |= SDL_GL_DOUBLEBUFFER; /* Enable double buffering */
    videoFlags |= SDL_HWPALETTE;       /* Store the palette in hardware */
    videoFlags |= SDL_RESIZABLE;       /* Enable window resizing */

    /* This checks to see if surfaces can be stored in memory */
    if ( videoInfo->hw_available )
	videoFlags |= SDL_HWSURFACE;
    else
	videoFlags |= SDL_SWSURFACE;

    /* This checks if hardware blits can be done */
    if ( videoInfo->blit_hw )
	videoFlags |= SDL_HWACCEL;

    /* Sets up OpenGL double buffering */
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

    /* get a SDL surface */
    surface = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,
				videoFlags );

    /* Verify there is a surface */
    if ( !surface )
	{
	    fprintf( stderr,  "Video mode set failed: %s\n", SDL_GetError( ) );
	    Quit( 1 );
	}

    /* initialize OpenGL */
    tarr[9].texture = pngBind("forest.png",PNG_BUILDMIPMAPS,PNG_SOLID,NULL,GL_REPEAT,GL_NEAREST,GL_NEAREST);
    tarr[10].texture = pngBind("swamp.png",PNG_BUILDMIPMAPS,PNG_SOLID,NULL,GL_REPEAT,GL_NEAREST,GL_NEAREST);
    tarr[11].texture = pngBind("forest.png",PNG_BUILDMIPMAPS,PNG_SOLID,NULL,GL_REPEAT,GL_NEAREST,GL_NEAREST);
    initGL( );
    glBindTexture(GL_TEXTURE_2D,0);
    

    /* resize the initial window */
    resizeWindow( SCREEN_WIDTH, SCREEN_HEIGHT );


    st = 1;
    /* wait for events */
    while ( !done )
	{
	    /* handle the events in the queue */

	    while ( SDL_PollEvent( &event ) )
		{
		    switch( event.type )
			{
			case SDL_ACTIVEEVENT:
			    /* Something's happend with our focus
			     * If we lost focus or we are iconified, we
			     * shouldn't draw the screen
			     */
                            st = 1;
			    if ( event.active.gain == 0 )
				isActive = FALSE;
			    else
				isActive = TRUE;
			    break;			    
			case SDL_VIDEORESIZE:
			    /* handle resize event */
			    surface = SDL_SetVideoMode( event.resize.w,
							event.resize.h,
							16, videoFlags );
			    if ( !surface )
				{
				    fprintf( stderr, "Could not get a surface after resize: %s\n", SDL_GetError( ) );
				    Quit( 1 );
				}
			    resizeWindow( event.resize.w, event.resize.h );
                            st = 1;
			    break;
			case SDL_KEYDOWN:
			    /* handle key presses */
			    handleKeyPress( &event.key.keysym );
             st = 1;
			    break;
         case SDL_KEYUP:
             handleKeyUp(&event.key.keysym);
             st = 1;
             break;
			case SDL_QUIT:
			    /* handle quit requests */
			    done = TRUE;
			    break;
			default:
             st = 0;
			    break;
			}
		}
            if (keydown) {
              st = 1;
              switch (keyd) {
               case 0:
               yloc = yloc-1;
               break;
              case 1:
               yloc = yloc+1;
               break;
              case 2:
               xloc = xloc+1; 
               break;
              case 3:
               xloc = xloc-1;
               break;
	      default:
	       break;
	      }
         chwindow();
       }         
	    /* draw the scene */
	    if ( isActive)
		drawGLScene( );
	}
    for (x = 0;x<xsize*SCALE;x++) free(hlist[x]);
    free(hlist); 
    for (x = 0;x<xsize;x++) free(ttype[x]);
    free (ttype);
    /* clean ourselves up and exit */
    Quit( 0 );

    /* Should never get here */
    return( 0 );
}
